/*****************************************************************************
Copyright (C) 2018  Mate Soos, Davin Choo, Kian Ming A. Chai, DSO National Laboratories

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
***********************************************/

#ifndef DIMACSCACHE_H__
#define DIMACSCACHE_H__

#include <vector>
#include "bosphorus/solvertypesmini.hpp"
using namespace Bosph;

namespace BLib {

class DIMACSCache
{
   public:
    DIMACSCache()
    {}

    DIMACSCache(const char* _fname);
    void addClause(const Lit* lits, const uint32_t size);

    uint32_t getMaxVar(void) const
    {
        return maxVar;
    }

    const std::vector<Clause>& getClauses(void) const
    {
        return clauses;
    }

   private:
    std::vector<Clause> clauses;
    uint32_t maxVar = 0;
    const char* fname = nullptr;
};

}

#endif
